#New ADVX macros
%define ADVXdir %{_datadir}/ADVX
%{expand:%(cat %{ADVXdir}/ADVX-build)}

%{expand:%%define apache_version %(rpm -q apache-devel|sed 's/apache-devel-\([0-9].*\)-.*$/\1/')}
%{expand:%%define apache_release %(rpm -q apache-devel|sed 's/apache-devel-[0-9].*-\(.*\)$/\1/')}

%{expand:%%define mm_major %(mm-config --version|sed 's/MM \([0-9]\)\.\([0-9.].*\) \(.*\)$/\1/')}
%{expand:%%define mm_minor %(mm-config --version|sed 's/MM \([0-9]\)\.\([0-9.].*\) \(.*\)$/\2/')}
%define mm_version %{mm_major}.%{mm_minor}

%define name mod_antihak
%define version 0.3.1c
%define srcver 0.3.1-beta
%define release 10mdk

Summary: Antihak module for Apache
Name: %{name}
Version: %{version}
Release: %{release}
Source0: http://prdownloads.sourceforge.net/apantihak/%{name}-%{srcver}.tar.bz2
Patch0: mod_antihak-iptables.patch.bz2
Patch1: mod_antihak-0.3.1-beta-apacheloc.patch.bz2
Patch2: mod_antihak-0.3.1b-server.patch.bz2
URL: http://apantihak.sourceforge.net/
License: GPL
Group: System/Servers
BuildRoot: %{_tmppath}/%{name}-buildroot
Prefix: %{_prefix}

Prereq: apache = %{apache_version}
Prereq:	apache-common >= %{apache_version}
Prereq:	apache-conf >= %{apache_version}
Prereq: mm = %{mm_major}.%{mm_minor}

BuildRequires: ADVX-build >= 1.2
BuildRequires: apache-devel
Requires:	iptables sudo

%description
mod_antihak is an Apache Module designed to eliminate the CodeRed and Nimda
worm's network bandwidth consumption. We're working to make it as easy as
writing a line of text to add more worms! :)

%prep
%setup -q -n %name-%srcver
cd src; mv * .. ; cd .. ; rmdir src
pwd
%patch0 -p0
%patch1 -p2
%patch2 -p0

%build
%serverbuild
export APACHE_APXS="%{_sbindir}/apxs" 
%configure --with-apache=/usr/sbin/httpd
#echo "AUTOMAKE_OPTIONS=no-exeext" >> mod_antihak/Makefile.am
touch tools/depcomp
%make

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/%{_libdir}/apache-extramodules
install mod_antihak/mod_antihak.so \
	%{buildroot}/%{_libdir}/apache-extramodules
chmod 644 AUTHORS COPYING ChangeLog INSTALL NEWS TODO

%clean
rm -rf %{buildroot}

%pre
#Check config file sanity
%AP13pre

%post
if [ $1 = "1" ]; then 

if [ `fgrep "apache ALL= NOPASSWD: /sbin/iptables" /etc/sudoers | wc -l` = 0 ]
then
	echo "apache ALL= NOPASSWD: /sbin/iptables" >> /etc/sudoers
fi

#We're in Install mode, add module to the config files
for config in %{ap_base}/conf/{httpd,httpd-perl}.conf; do
	if [ -x %{_sbindir}/advxaddmod -a -e $config ]; then
		%{_sbindir}/advxaddmod $config \
		extramodules/mod_antihak.so mod_antihak.c antihak_module
	fi
done
%ADVXpost
fi

if [ $1 -gt 1 ]; then 
#We're in *upgrade mode*. Since we can't be sure the configuration files
#are sane, remove module from the conf files to clean them, re-add again 
#in a way that the older module we're replacing won't try to erase (the 
#post scripts were broken on some packages), and finally clean the module
#specific config file so it's compatible with the upgrade.
for config in %{ap_base}/conf/{httpd,httpd-perl}.conf; do
	if [ -x %{_sbindir}/advxdelmod -a -e $config ]; then
		%{_sbindir}/advxdelmod $config \
		extramodules/mod_antihak.so mod_antihak.c antihak_module \
		$config
	fi
	if [ -x %{_sbindir}/advxaddmod -a -e $config ]; then
		%{_sbindir}/advxaddmod $config \
		extramodules/mod_antihak.so mod_antihak.c antihak_module
	fi
done
%ADVXpost
fi

%postun
if [ $1 = "0" ]; then 

if [ `fgrep "apache ALL= NOPASSWD: /sbin/iptables" /etc/sudoers | wc -l` != 0 ]
then
        alias FIXME="perl -pi -e"
	FIXME 's|apache ALL= NOPASSWD: /sbin/iptables\n||' /etc/sudoers
fi


for config in %{ap_base}/conf/{httpd,httpd-perl}.conf; do
	if [ -x %{_sbindir}/advxdelmod -a -e $config ]; then
		%{_sbindir}/advxdelmod $config \
		extramodules/mod_antihak.so mod_antihak.c antihak_module
	fi
done
%ADVXpost
fi

%files
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog INSTALL NEWS TODO
%{_libdir}/apache-extramodules/mod_antihak.so

%changelog
* Tue Sep 16 2003 Jean-Michel Dault <jmdault@mandrakesoft.com> 0.3.1c-10mdk
- rebuild with apache 1.3.28

* Thu Feb 13 2003 Jean-Michel Dault <jmdault@mandrakesoft.com> 0.3.1c-9mdk
- new macros from ADVX-build
- add no-exeext to Makefile.am to make automake happy.

* Sat Dec 07 2002 Olivier Thauvin <thauvin@aerov.jussieu.fr> 0.3.1beta-8mdk
- Don't hardcore %%apache_version, get from system on build

* Fri Nov  8 2002 Jean-Michel Dault <jmdault@mandrakesoft.com> 0.3.1beta-7mdk
- Rebuild for Cooker

* Mon Oct 28 2002 Jean-Michel Dault <jmdault@mandrakesoft.com> 0.3.1beta-6mdk
- New version

* Wed Jun 26 2002 Christian Belisle <cbelisle@mandrakesoft.com> 0.3.1beta-5mdk
- rebuild against new apache.

* Mon Apr 15 2002 Christian Belisle <cbelisle@mandrakesoft.com> 0.3.1beta-4mdk
- Apache 1.3.24
- Fix BuildRequires.
- Include Patch2 to know if the module is loaded or not.

* Tue Feb 05 2002 Christian Belisle <cbelisle@mandrakesoft.com> 0.3.1beta-3mdk
- rebuild against new apache.
- give the right path for apxs (patch1).

* Tue Dec 25 2001 Stefan van der Eijk <stefan@eijk.nu> 0.3.1beta-2mdk
- fix bug in calling iptables
- fix %%post and %%postun

* Mon Dec 24 2001 Stefan van der Eijk <stefan@eijk.nu> 0.3.1beta-1mdk
- first Mandrake version
